#include <windows.h>
#include <iostream>
#include <ctime>
#include <stdlib.h>
#include <string>

 /*
    Author: Geoffrey Hinds
    GDD: You are a bounty hunter you have tracked a target to this location.
    Your target is hiding in a secured bunker. You will have to hack the security protocols to get to them.
    You find a terminal and get started. Solve math problems to advance.
       
 */

void TypeString(std::string str, int speed) // types strings one letter at a time at the requested speed
{
    for (auto s : str)
    {                
        std::cout << s;
        Sleep( speed );
    }  
}

void PrintTop()
{
    system("CLS");
    TypeString("\n  ____________________________________________", 1);
    TypeString("\n //                                          \\\\", 1);
    TypeString("\n//********************************************\\\\", 1);
    TypeString("\n||********************************************||", 1);
}

void PrintBottom(bool ClearScreen)
{
    TypeString("\n||********************************************||", 1);
    TypeString("\n\\\\********************************************//", 1);
    TypeString("\n \\\\__________________________________________//\n", 1);
    Sleep(1000);
    if (ClearScreen)
    {
        system("CLS");
    }    
}

void PrintIntroduction(int Difficulty, int MaxDifficulty)
{
    // Print welcome messages to terminal
    if (Difficulty == 1)
    {
        PrintTop();
        TypeString("\n|| Your target is hiding in a secured bunker  ||", 10);
        TypeString("\n|| You will have to hack the security         ||", 3);
        TypeString("\n|| protocols to get to them.                  ||", 3);
        TypeString("\n||                                            ||", 1);
        PrintBottom(false);

        Sleep(3000);
        system("CLS");
        
        PrintTop();
        std::string str = "\n|| There are ";
        str += std::to_string(MaxDifficulty);
        str += " levels of protocols!           ||";
        TypeString(str, 10);
        std::string str2 = "\n||  Security protocol level ";
        str2 += std::to_string(Difficulty);
        str2 += ":Enabled         ||";
        TypeString(str2, 10);
        TypeString("\n||                                            ||", 1);
        TypeString("\n|| Enter the correct code to continue...      ||", 3);
    }
    else
    {
        PrintTop();
        std::string str2 = "\n||  Security protocol level ";
        str2 += std::to_string(Difficulty);
        str2 += ":Enabled         ||";
        TypeString(str2, 10);

        if (Difficulty != MaxDifficulty)
        {
            std::cout << "\n||  ";
            std::string str = "You have ";
            str += std::to_string(MaxDifficulty-Difficulty);
            str += " levels left to go!             ";
            TypeString(str, 3);
            std::cout << "||";
        }        
        else
        {
            std::cout << "\n";
            TypeString("||  This is the last security level!          ||", 3);
        }
        
    }
}

bool PlayGame(int Difficulty, int MaxDifficulty) 
{
    PrintIntroduction(Difficulty, MaxDifficulty);

    // Setup numbers
    const int CodeA = rand() % Difficulty + Difficulty;    
    const int CodeB = rand() % Difficulty + Difficulty;
    const int CodeC = rand() % Difficulty + Difficulty;

    const int CodeSum       = CodeA + CodeB + CodeC;
    const int CodeProduct   = CodeA * CodeB * CodeC;
    
    // Print sum and product to the terminal
    
    TypeString("\n||********************************************||", 1);
    TypeString("\n||  + There are three numbers in the code     ||", 3);
    TypeString("\n||", 1);
    std::string str = "  + The codes add-up to: ";
    str += std::to_string(CodeSum);
    TypeString(str, 3);
    if (CodeSum >= 10)
    {
        if (CodeSum >= 100)
        {
            TypeString("                ||", 3);
        }
        else
        {
            TypeString("                 ||", 3);
        }
        
    }
    else 
    {                
        TypeString("                  ||", 3);
    }   
    TypeString("\n||", 1);
    str = "  + The codes multiply to give: ";
    str += std::to_string(CodeProduct);
    TypeString(str, 3);
    if (CodeProduct >= 10)
    {
        if (CodeProduct >= 100)
        {
            TypeString("         ||", 3);
        }
        else
        {
            TypeString("          ||", 3);
        }
        
    }
    else
    {                    
            TypeString("           ||", 3);
    }   
    TypeString("\n||********************************************||", 1);
    TypeString("\n||  Enter your three guesses below...         ||", 3);    
    PrintBottom(false);

    // Store player guess
    int GuessA, GuessB, GuessC;
    std::cin >> GuessA >> GuessB >> GuessC;

    int GuessSum = GuessA + GuessB + GuessC;
    int GuessProduct = GuessA * GuessB * GuessC;

    // Check if players guess is correct
    if (GuessSum == CodeSum && GuessProduct == CodeProduct)
    {
        if (Difficulty == MaxDifficulty)
        {
            PrintTop();
            TypeString("\n||  You Hacked the last protocol!             ||", 3);
            TypeString("\n||  Access Granted                            ||", 10);
            TypeString("\n||  Bunker door opening...                    ||", 15);
            TypeString("\n||                                            ||", 1);
            PrintBottom(true);
        }
        else
        {
            PrintTop();
            TypeString("\n||  ", 1);
            std::string str = "You Hacked the level ";
            str += std::to_string(Difficulty);
            str += " security protocol! ";
            TypeString(str, 30);
            TypeString("||", 1);
            PrintBottom(true);
        }

        return true;
    }
    else
    {
        PrintTop();
        std::cout << "\n";
        TypeString("||  The HackFailed! Try Again...              ||", 30);
        PrintBottom(true);

        return false;
    }    
}

int main()
{
    srand(time(NULL));
    int LevelDifficulty = 1;
    const int MaxDifficulty = 5;

    while (LevelDifficulty <= MaxDifficulty)
    {
        bool bLevelComplete = PlayGame(LevelDifficulty, MaxDifficulty);
        std::cin.clear();  // Clears any errors
        std::cin.ignore(); // Discards the buffer

        if (bLevelComplete)
        {
            ++LevelDifficulty;
        }
        
    }
        PrintTop();
        TypeString("\n||  It's about time you finished!             ||", 15);
        TypeString("\n||  My granny can hack faster than you!       ||", 15);
        TypeString("\n||  Well your targets inside! Go get em!!!    ||", 15);
        TypeString("\n||  Don't forget they're worth more alive!    ||", 15);        
        PrintBottom(false);

    return 0;
}

/*
    alternate way to complete for unreal game mode where the hacking device unlocks after beating it once properly
    attach hacking device - it is a touchscreen phone with 3 buttons split across the vertical or horizontal axis
    if(diff <= maxdiff)
    {
        button text shows as follows
        button1 = Initiate Connection
        button2 = Search Memory Locations
        button3 = Retrieve Codes
        each button text is changed to CodeA, CodeB and CodeC for that security level
        user can then input codes
    }
    detach hacking device
    show victory message
*/